import sys, os
import numpy as np
from scipy.optimize import curve_fit
from matplotlib import pyplot as plt

import BioNetTopology

#
# Graph shit
#

SMALL = 8
MEDIUM = 10
LARGE = 12

#
# Data
#

# Constants
numNodes = 10000

# Variables
vfs = [0.05, 0.07, 0.1]
ns = [4,6,8,14]
rates = [1000]
radii = [1.0, 2.5]
numRuns = 3

#vfs = [0.07]
#ns = [8]
#rates = [1000]
#radii = [2.5]

#numRuns = 3

# Loop over variables
limit = 3000
numOk = 0
numPossible = len(vfs) * len(rates) * len(ns) * len(radii) * numRuns
for radius in radii:
	for rate in rates:

		for vf in vfs:

			for s in ns:

				for nr in range(numRuns):

					# Get the topology
					iFname = "../results/N%dSites%02dRadius%05.2fRate%5.2fvf%0.4fKineticsRun%d_Clusters.dat" % (numNodes, s, radius, rate, vf, nr)
					if(not os.path.exists(iFname)):
						numPossible -= 1
						continue

					# Get data
					fin = open(iFname, "r")
					lines = fin.readlines()
					fin.close()

					numClusters = int(lines[0].split()[1])
					lengths = []
					for line in lines:
						sline = line.split(",")
						lengths.append(len(sline))

					minCluster = min(lengths)
					maxCluster = max(lengths)

					if (maxCluster >= limit):
						numOk += 1
					else:
						print("Radius %.2f, vf: %.4f, ns: %d, Run %d\nNum Clusters: %d, Max: %d, Min: %d\n" % (radius, vf, s, nr, numClusters, maxCluster, minCluster))

print("%d ok out of a possible %d" % (numOk, numPossible))
