import sys, os
import numpy as np
from scipy.optimize import curve_fit
from matplotlib import pyplot as plt

import BioNetTopology

#
# Graph shit
#

SMALL = 8
MEDIUM = 10
LARGE = 12

#
# Data
#

# Constants
numNodes = 10000

# Variables
vfs = [0.005, 0.01, 0.05, 0.07, 0.1]
#vfs = [0.05]
ns = [4,6,8,14]
rates = [1000]
radii = [1.0,2.5]
numRuns = 3

#vfs = [0.07]
#ns = [8]
#rates = [1000]
#radii = [2.5]

#numRuns = 3
fig = plt.figure(figsize=(3.2,3.2))

# Loop over variables
for radius in radii:
	for rate in rates:

		for s in ns:

			for nr in range(numRuns):

				vIndex = 0
				for vf in vfs:

					# Get the topology
					iFname = "../results/N%dSites%02dRadius%05.2fRate%5.2fvf%0.4fKineticsRun%d_Clusters.dat" % (numNodes, s, radius, rate, vf, nr)
					if(not os.path.exists(iFname)):
						continue

					# Get data
					fin = open(iFname, "r")
					lines = fin.readlines()
					fin.close()

					# Num clusters
					MT = int(lines[0].split()[1])

					# Cluster sizes
					M = []
					for line in lines[1:]:
						sline = line.split(",")
						M.append(len(sline))


					# Bin the data logarithmically
					bins = np.array([ [i, i + 1] for i in range(0, 10010,1)])
#					bins[0][0] = 1
					numBins = bins.shape[0]

					# X is midpoint
#					X = np.array([0.5 * (a[0] + a[1]) for a in bins])
					X = np.array([a[0] for a in bins])

					# Y needs building
					Y = np.array([0.0 for a in bins])
					for Mi in M:
						for i in range(numBins):
							if Mi >= bins[i][0] and Mi < bins[i][1]:
								Y[i] += 1
								break

					# Reduce
					Y /= MT

					# Plot
					plt.loglog(X,Y,"oC%d" % (vIndex), label=r"f$_v$ = %.2f" % (vf))

					vIndex += 1

				fullRange = np.array(range(0,10010))
#				plt.loglog(X,np.power(X - (X[0] - 1),-2.2), "--b")

				# Prettify
				plt.xlabel("Cluster Size", fontsize=MEDIUM)
				plt.ylabel("Relative Number of Clusters", fontsize=MEDIUM)
				plt.xlim(1,16500)
				plt.ylim(10**(-3), 10**1)

				plt.xticks([0.5, 1,10,100,1000,10000], ["","1","10","100","1000", "10000"])
				plt.legend(loc=0, fontsize=SMALL, ncol=2)

				plt.tight_layout()
				plt.savefig("../results/N%dSites%02dRadius%05.2fRate%5.2fKineticsRun%d_Percolation.png" % (numNodes,s,radius,rate,nr), dpi=100)
#				plt.show()
#				sys.exit()
				plt.clf()
