import sys, os
import numpy as np

import BioNetInput, BioNetTrajectory

#
# Data
#

# Constants
numNodes = 10000

# Variables
vfs = [0.05, 0.07, 0.1]
ns = [4,6,8,14]
rates = [1000]

radii = [1.0,2.5]

numRuns = 3

# Loop over variables
for radius in radii:
	for rate in rates:

		sIndex = 0
		for s in ns:

			vIndex = 0
			for vf in vfs:

				# Build data sets
				minSize = np.inf

				# Counts frames
				traj = BioNetTrajectory.BioNetTrajectory()
				for nr in range(numRuns):

					# Load script
					tFname = "../output/N%dSites%02dRadius%05.2fRate%5.2fvf%0.4fKineticsRun%d.bntrj" % (numNodes, s, radius, rate, vf, nr)
					if(not os.path.exists(tFname)):	
						continue


					numFrames = traj.countFrames(tFname)
					
					if numFrames < minSize:
						minSize = numFrames
			

				# Read the final frame
				for nr in range(numRuns):

					# Load scripts
					iFname = "../input/N%dSites%02dRadius%05.2fRate%5.2fvf%0.4fKineticsRun%d.xml" % (numNodes, s, radius, rate, vf, nr)
					tFname = "../output/N%dSites%02dRadius%05.2fRate%5.2fvf%0.4fKineticsRun%d.bntrj" % (numNodes, s, radius, rate, vf, nr)
					if(not os.path.exists(tFname)):	
						continue

					# Files
					traj = BioNetTrajectory.BioNetTrajectory()
					traj.loadFrame(tFname, minSize-1)
					inp = BioNetInput.BioNetInput()
					inp.load(iFname)

#					voxDims = radius / 2.0
#					voxDims = radius
					voxDims = radius * 4.0

					# Calc pores (and write to file)
					pFname = "../output/N%dSites%02dRadius%05.2fRate%5.2fvf%0.4fKineticsRun%d.bnpores" % (numNodes, s, radius, rate, vf, nr)
					traj.frame[0].calculatePoreDistribution(inp, voxDims, calculateThroats = False, fname = pFname)


				vIndex += 1

			sIndex += 1
