import sys, os
import numpy as np
from matplotlib import pyplot as plt

#
# Graph shit
#

SMALL = 8
MEDIUM = 10
LARGE = 12

#
# Data
#

# Constants
numNodes = 10000

# Variables
vfs = [0.005, 0.01, 0.05, 0.07, 0.1]
#vfs = [0.01,0.1]
ns = [4,6,8,14]
#ns = [6]
rates = [1000]

numRuns = 3

radii = [1.0,2.5]
#radii = [1.0]

# Figure
fig = plt.figure(figsize=(3.2,3.2))

# Loop over variables
for radius in radii:
	rIndex = 0
	for rate in rates:

		vIndex = 0
		for vf in vfs:

			sIndex = 0
			for s in ns:

				rs = None
				rdfs = []
				rdfErrs = []

				# Load data file
				iFname = "../results/N%dSites%02dRadius%05.2fRate%5.2fvf%0.4fKinetics_RDFTraceLOL.dat" % (numNodes, s, radius, rate, vf)
				fin = open(iFname, "r")
				lines = fin.readlines()
				fin.close()

				if len(lines) == 0:
					continue

				for i in range(int(len(lines) / 3)):
					if(i == 0):
						rs = np.array([float(d) for d in lines[3 * i].strip().split(",")])
					rdfs.append([float(d) for d in lines[3 * i + 1].strip().split(",")])
					rdfErrs.append([float(d) for d in lines[3 * i + 2].strip().split(",")])			
			
				fin.close()

				# Normalise
				rs = rs / radius

				# Average and errors
				rdfs = np.mean(rdfs, axis=0)
				rdfErrs = np.mean(rdfErrs, axis=0)

				# Add to plot
	#			plt.errorbar(rs[::], rdfs[::], yerr=rdfErrs[::], fmt="--C%d" % (sIndex), label="%d Sites" % (s))
				plt.semilogy(rs[:-1:], rdfs[:-1:], "--C%d" % (sIndex), label=r"$N_s = $%d" % (s))
				
				sIndex += 1

			# Prettify
			plt.ylim(0.1,300)
			plt.xlabel(r"Radial Distance ($R$)", fontsize=MEDIUM)
			plt.ylabel("Radial Distribution function", fontsize=MEDIUM)
			plt.legend(loc=0, fontsize=SMALL)

			plt.tight_layout()
			oFname = "../results/N%dRadius%05.2fRate%5.2fvf%0.4fKinetics_RDFTraceLOL.png" % (numNodes, radius, rate, vf)
			plt.savefig(oFname, dpi=100)
			plt.clf()

